clc;
mode(1)
// Returns artificially generated test signals, sig, and mixed
// signals, mixedsig. Signals are row vectors of
// matrices. Input mixedsig to FastICA - GUI to see how it works.
// 
// Use plot data to visualize the mixed signal
// Then do a ICA to demix the signals
//
mode(-1);
lines(0);

//my_handle = scf(100001);
//clf(my_handle,"reset");
//demo_viewCode("ica3.dem.sce");

// DEMO START

//my_plot_desc          = "ica";
//my_handle.figure_name = my_plot_desc;

// @(#)$Id: demosig.m,v 1.2 2003/04/05 14:23:57 jarmo Exp $

//create source signals (independent components)
N=500; //data size

v=[0:N-1];
sig=[];
sig(1,:)=sin(v/2); //sinusoid
sig(2,:)=((modulo(v,23)-11)/9).^5; //funny curve
sig(3,:)=((modulo(v,27)-13)/9); //saw-tooth
sig(4,:)=((rand(1,N)<.5)*2-1).*log(rand(1,N)); //impulsive noise

for t=1:4
sig(t,:)=sig(t,:)/st_deviation(sig(t,:));
end

//remove mean (not really necessary)

[sig mean_sig]=remmean(sig);

//create mixtures

Aorig=rand(size(sig,1),size(sig,1));
mixedsig=(Aorig*sig);


//[estimatesig] = fasticag(mixedsig);//,m); 
fastica_gui(mixedsig);
// m=4
// for i=1:m
// 
// subplot(3,m,i);
// title('source data');
// plot(sig(i,:));         // plot A
// 
// 
// 
// subplot(3,m,i+m);
// title('mixed data');
// plot(mixedsig(i,:));      // plot mixing 1
// 
//        subplot(3,m,i+2*m);    // compute and plot unminxing using fastICA	
// title('unmixed data');
//  plot(estimatesig(i,:));
// 
// end
