//
mode(-1);
lines(0);

my_handle = scf(100001);
clf(my_handle,"reset");
//demo_viewCode("ica.dem.sce");

// DEMO START

my_plot_desc          = "ica";
my_handle.figure_name = my_plot_desc;

N=1000;                                         //number of training samples
m=3;                                              //number of components


s=[];
for i=1:m
   select (i),
   case 1, news=rand(1,N);
   case 2, news=sin((1:N)/N*20);
   case 3, news=grand(1,1000,'exp',1);

   end
   news=news-mean(news,'m');   // centers data
   news=news/mtlb_std(news,1);  // scales data
   s=[s; news];
end

Wg=rand_orth(m);
x=Wg*s;           


[c,A,Wcca] = fastica(x);//,m); 
 //[Wcca,w,sig,c] = wasobi(x,5,0.9);  
Wcca=real(Wcca);
sestimate=Wcca*x;

for i=1:m

subplot(3,m,i);
title('source data');
plot(s(i,:));         // plot A



subplot(3,m,i+m);
title('mixed data');
plot(x(i,:));      // plot mixing 1

       subplot(3,m,i+2*m);    // compute and plot unminxing using fastICA	
title('unmixed data');
 plot(sestimate(i,:));

end






