//
mode(-1);
lines(0);

my_handle = scf(100001);
clf(my_handle,"reset");
//demo_viewCode("ica.dem.sce");

// DEMO START

my_plot_desc          = "ica";
my_handle.figure_name = my_plot_desc;



A = sin(linspace(0,50, 1000));   // A
B = sin(linspace(0,37, 1000)+5); // B
subplot(3,2,1);
title('source data');
plot(A);         // plot A

subplot(3,2,2);
title('source data');
plot(B, 'r');    // plot B

M1 = A - 2*B;                  // mixing 1
M2 = 1.73*A+3.41*B;   
         // mixing 2
subplot(3,2,3);
title('mixed data');
plot(M1);      // plot mixing 1

subplot(3,2,4);
title('mixed data');
plot(M2, 'r'); // plot mixing 2


c = fastica([M1;M2]);   
       subplot(3,2,5);    // compute and plot unminxing using fastICA	
title('unmixed data');
 plot(c(1,:));
subplot(3,2,6);
title('unmixed data');
 plot(c(2,:),'r');



