function [new_x, Xmean] = remmean(x);
// remove the mean from vectors
// Calling Sequence
// [newVectors, meanValue] = remmean(vectors);
// Description
// Removes the mean of row vectors.
// Returns the new vectors and the mean.
//
// Authors
// H. Nahrstaedt - 2011
//   (C) 1996-2005 by Hugo Gävert, Jarmo Hurri, Jaakko Särelä, and Aapo Hyvärinen. 

// @(#)$Id: remmean.m,v 1.2 2003/04/05 14:23:58 jarmo Exp $

//newVectors = mtlb_zeros (size (vectors));
//meanValue = mtlb_mean (vectors')';
//newVectors = vectors - meanValue * ones (1,size (vectors, 2));

[d N]=size(x);
Xmean=mean(x,2);
new_x=x-Xmean*ones(1,N); 


endfunction